
(* Load the original picture strberry and try to make a ptcGraph compatible picture strberry2 *)

uses
  SysUtils;
  
var
  h: integer;
  l: integer;
  r: integer;
  p: PAnsiChar;
  
  i: longint;
  b: byte;
  w: word;
  
begin
  h := FileOpen('strberry', fmOpenRead);
  l := FileSeek(h, 0, fsFromEnd);
  FileSeek(h, 0, fsFromBeginning);
  p := AllocMem(Succ(l));
  r := FileRead(h, p^, l);
  FileClose(h);
  
  h := FileCreate('strberry2');
  
  i := 16;
  FileWrite(h, i, SizeOf(i));
  FileWrite(h, i, SizeOf(i));
  i := 0;
  FileWrite(h, i, SizeOf(i));
  
  for i := 6 to r - 1 do
  begin
    b := byte(p[i]) and %00001111;
    w := b;
    FileWrite(h, w, SizeOf(word));
    
    b := byte(p[i]) and %11110000;
    b := b shr 4;
    w := b;
    FileWrite(h, w, SizeOf(word));
  end;
  FileClose(h);
  
  FreeMem(p);
end.

(*
  4 bit format (VGA or 16 color)

  In this case each byte of image data represents two pixels (biBitCount == 4).
  Bits represent the color of the pixel in descending order; i.e. the first pixel
  is stored in bits 7-4 of the byte, the second pixel in bits 3-0. The four bits
  specify the number of the color palette entry (color 0 through color 15).
*)
